#include <mpi.h>
#include <stdio.h>
int main(int argc,char**argv)
{
  MPI_Init(&argc,&argv);
  int procs,rank,in,out;
  MPI_Comm_size(MPI_COMM_WORLD,&procs);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  out = rank;
  if (rank==0) 
    MPI_Sendrecv(&out,1,MPI_INT,rank+1, 17,
                 &in,1,MPI_INT,procs-1, 18,
                 MPI_COMM_WORLD,MPI_STATUS_IGNORE);
  else if (rank==procs-1)
    MPI_Sendrecv(&out,1,MPI_INT,0, 17,
                 &in,1,MPI_INT,rank-1, 18,
                 MPI_COMM_WORLD,MPI_STATUS_IGNORE);
  else
    MPI_Sendrecv(&out,1,MPI_INT,rank+1, 17,
                 &in,1,MPI_INT,rank-1, 18,
                 MPI_COMM_WORLD,MPI_STATUS_IGNORE);
  if (rank==0)
    printf("rank 0 received %d\n", in);
  MPI_Finalize();
  return 0;
}
